#include <setjmp.h>
#include "nodetypes.h" /* include perl generated nodetype list */

typedef struct nodestruct
{
	struct nodestruct *nodes[5];
	unsigned short numnodes,line;
	int type;	/* what sort of node this is */

	struct
	{
		char str[32];
		long num;
		long num2,num3,num4;	/* in case we need more */
	} value;

} NODE;

#define	LISTNUMS	8
typedef struct liststruct
{
	struct liststruct *next;
	long nums[LISTNUMS];	/* assorted data */
	void *data;
	unsigned long flags;
	char str[32];
} LIST;

/* These are found in the flags field of functions and library calls in
   the appropriate lists.*/

#define	LF_RETURNS	1
#define	LF_LIBCASE	2
#define LF_VARARGS	4

/* These are used to determine special traits of functions and library calls,
   and are flags in the str[0] part of the list structure. */

#define FUNCB_RETURNS	1	/* function returns a value */
#define FUNCB_VARARGS	2	/* function (or libcall) has variable arguments */
#define FUNCB_ISSTMT	4	/* is a statement and so must DROP if FUNCB_RETURNS is also true*/

#ifdef __cplusplus
extern "C"
{
#endif

extern unsigned long getcompilerpos(void);

extern void output(unsigned long);
extern void outputtree(NODE *);
extern void outputreturn(void);
extern int flushbuffer(void);
extern int yylex(void);
extern void yyerror(char *);
extern void panic(char *,...);
extern void yyraise(char *,...);
extern LIST *addlist(LIST *,char *,int,...);
extern void deletelist(LIST *);
extern LIST *find(LIST *,char *);

#ifdef __cplusplus
}
#endif


extern short debug;
