/*
	This is the machine-dependent graphics stuff.
	One of each of these functions must be written
	for each target platform.
*/


void graph_init();		/* Open display area and clear it, etc. */
void graph_show();		/* Show the data stored in the buffer */
void graph_shutdown();	/* Shutdown the graphics */

extern int win_x,win_y,palette_size,win_scale;

#define graph_xsize()	win_x
#define graph_ysize()	win_y
#define graph_psize()	palette_size
#define graph_getscale()	win_scale

/* these initialisation routines must be called _before_ 
   graph_init() */

void graph_setsize(short s);			/* set scale. -1 is default. */
void graph_settiming(short timing);		/* set interrupt timing ratio */


/*
  Palettes are passed as an array of short[][3] - r,g,b.
*/
void graph_palette(short *);	/* set the palette to these shorts */

/****Thu Aug 18 20:16:56 1994*******************************************
 * periodic graphics check. This is to avoid actually doing the
 * palette stuff in interrupts.
 ***********************************************************************/

void graph_check(void);
 
