/*
	Interpreter for virtual machine
*/

void interp_init();			/* initialise the interpreter */
short interp_isfinished(void);	/* is the interpreter finished on this func? */
void interp_function(short n);/* start the interpreter on func n */
void interp_run(void);			/* run a single interpreter instruction */
void interp_choose(void);		/* choose a new image function */
char *interp_name(void);		/* get the name of the current function */

/* stack stuff */
#define	STACK_CHECK	1
#define	STACK_MACROS	1

#if STACK_MACROS
extern long eoffset;
extern long estack[];
extern int ipanic(char *);

#if STACK_CHECK
#define	Push(x)	{\
if(eoffset==STACKSIZE)panic("stack overflow");\
estack[eoffset]=(x);eoffset++;}

#define	Pop()	(\
eoffset?estack[--eoffset]:\
ipanic("stack underflow - too few args to function?"))


#define	Peek()	(\
eoffset?estack[eoffset-1]:\
ipanic("stack underflow"))

#else /* !STACK_CHECK */
#define	Push(x)	{estack[eoffset]=(x);eoffset++;}
#define	Pop()	(estack[--eoffset])
#define	Peek()	(estack[eoffset-1])

#endif /* STACK_CHECK */

#else /* !STACK_MACROS */

void Push(long);
long Pop(void);
long Peek(void);

#endif /* !STACK_MACROS */

#undef Push
void Push(long);
