/*
 * Library function tables - giving the index number of the function,
 * how many arguments it wants, and whether it returns a value.
 *
 */
static char rcsid[]="$Id: libcalls.c,v 1.2 1994/09/17 21:51:09 white Exp $";
#include <stdio.h>

#include "compiler.h"
#include "nodetypes.h"

struct LibTab {char *name;	int args; int doesreturn;};


/*
		The library call table. 

*/

static struct LibTab LibCallTab[]={


{"print",	1,0},		/* print a number to stdout */
{"point",	2,0},		/* plot a point in current col */
{"rect",	4,0},		/* draw a rect x1,y1,x2,y2 */
{"colour",	1,0},		/* change colour */
{"trace",	1,0},		/* set debugging state */
{"width",	0,1},		/* get screen width */
{"height",	0,1},		/* get screen height */
{"numcols",	0,1},		/* get number of colours */
{"hsineline",	7,0},		/* x,y,len,offset,scale,intens,paloffset */
{"vsineline",	7,0},		/* x,y,len,offset,scale,intens,paloffset */
{"hsawline",	7,0},		/* x,y,len,offset,scale,intens,paloffset */
{"vsawline",	7,0},		/* x,y,len,offset,scale,intens,paloffset */
{"hwaveline",	8,0},		/* w,x,y,len,offset,scale,intens,paloffset */
{"vwaveline",	8,0},		/* w,x,y,len,offset,scale,intens,paloffset */
{"newwave",	1,1},		/* size, returns handle */
{"waveset",	3,0},		/* handle,index,val */
{"newpal",	1,1},		/* size, returns handle */
{"palset",	3,0},		/* handle,index,rgbcol */
{"palreset",	0,0},		/* clear and free all palettes */
{"genpal",	6,0},		/* handle,fgcol,bgcol,up,down,offset */
{"palspeed",	2,0},		/* handle, new speed */
{"rgb",		3,1},		/* red,green,blue - returns colour */
{"imagedone",	0,0},		/* image done - do palettes after this */
{"rand",	1,1},		/* takes range, returns number. */
{"radial",	7,0},		/* w,x,y,size,offset,scale,intens */
{"drawmode",	1,0},		/* = drawmode flags. See buffer.c */
{"sin",		1,1},		/* 0<=x<4096 */
{"cos",		1,1},		/* ditto. */
{"hsv",		1,1},		/* hue, saturation, value */
{"plasma",	3,0},		/* grain,trellis,intens */

{NULL,0,0}
};

/* end of table */


LIST *getlibcall(char *n,NODE *args)
{
	int i;
	static LIST l;

	for(i=0;;i++)
	{
		l.flags=NULL;
		if(!LibCallTab[i].name)break;

		if(!strcmp(n,LibCallTab[i].name))
		  {
			strcpy(l.str,n);
			l.nums[0]=i;
			l.nums[5]=LibCallTab[i].args;
			if(l.nums[5]<0)l.flags|=LF_VARARGS;
			if(l.nums[1]=LibCallTab[i].doesreturn)
			  l.flags|=LF_RETURNS;
			l.next=NULL;
			return(&l);
		  }
	  }
	return(NULL);
}

char *getlibcallname(int n)
{
	if(n>=0 && n<(sizeof(LibCallTab)/sizeof(struct LibTab)))
		return(LibCallTab[n].name);
	else
	{
		return("bad call");
	}
}

