/*
		Library calls. Feel free to add. Remember to pop things off the stack
		in reverse order.
*/

static char rcsid[]="$Id: libinter.c,v 1.2 1994/09/17 21:51:09 white Exp $";

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <math.h>

#include "spring.h"
#include "buffer.h"
#include "graphics.h"
#include "waves.h"
#include "inter.h"
#include "palette.h"
#include "plasma.h"

int currentcol=0;

static void L_PrintNum()
{
	long n=Pop();

	printf("number: %ld\n",n);
}

static void L_Point()
{
  int x,y;
  y=Pop();x=Pop();
  buffer_point(x,y,currentcol);
}

static void L_Rect()
{
  int x1,y1,x2,y2;
  y2=Pop();x2=Pop();
  y1=Pop();x1=Pop();
  buffer_rect(x1,y1,x2,y2,currentcol);
}

static void L_Colour()
{
  currentcol=Pop();
}

static void L_Trace()
{
  debug=Pop();
}

static void L_Width()
{
  Push(graph_xsize());
}

static void L_Height()
{
  Push(graph_ysize());
}

static void L_Numcols()
{
  Push(graph_psize());
}

static void L_Imagedone()
{
  palette_startfadeout(0,0,0,1);
  palette_reset();
}

static void L_Rand()
{
	Push(rand()%Pop());
}  

static void L_Dmode()
{
	buffer_setdrawmode(Pop());
}

static void L_Sine()
{
  Push((long)mSin((int)Pop()));
}

static void L_Cosine()
{
  Push((long)mCos((int)Pop()));
}

void(*LibFuncs[])()=
{
	L_PrintNum,
	L_Point,
	L_Rect,
	L_Colour,
	L_Trace,
	L_Width,
	L_Height,
	L_Numcols,
	L_HSineLine,
	L_VSineLine,
	L_HSawLine,
	L_VSawLine,
	L_HWaveLine,
	L_VWaveLine,
	L_WaveNew,
	L_WaveSet,
	L_NewPalette,
	L_PaletteSet,
	L_PaletteReset,
	L_GenPalette,
	L_PaletteSpeed,
	L_MkRGB,
	L_Imagedone,
	L_Rand,
	L_Radial,
	L_Dmode,
	L_Sine,
	L_Cosine,
	L_MkHSV,
	L_Plasma,
};

