#include <stdio.h>
#include <sys/time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <signal.h>

#include "spring.h"
#include "graphics.h"
#include "palette.h"

static char rcsid[]="$Id: nographics.c,v 1.2 1994/09/17 21:51:09 white Exp $";


/*
	The machine-dependent graphics (NONE - debugging)
*/

/*
		These settings work well on a server
		with a 1024x768 display
*/

#define	XSIZE	512
#define	YSIZE	384
#define	TIMEOUT	50000L

int holding=0,timeout=TIMEOUT;
static int palette_size=0;
static int win_x=XSIZE,win_y=YSIZE;
extern char **argvec;
static int dis_x=0,dis_y=0;

static int do_tick=0;

void maketimer()
{
  static struct itimerval tim=
  {
	{0L,TIMEOUT},
	{0L,TIMEOUT}
  };

  struct itimerval otim;

  tim.it_interval.tv_usec=timeout;
  tim.it_value.tv_usec=timeout;

  setitimer(ITIMER_REAL,&tim,&otim);
}

void graph_tsig()
{
	signal(SIGALRM,graph_tsig);
	do_tick=1;
}

void graph_check()
{
	if(do_tick)
	{
		palette_run();
		graph_palette(palette_get());
		do_tick=0;
	}
}

void graph_setsize(short x,short y)
{
  win_x = (x>0)?x:XSIZE;
  win_y = (y>0)?y:YSIZE;
}

void graph_settiming(short timing)
{
  timeout=TIMEOUT*timing;
}

void graph_init()
{
  dis_x=win_x=640;
  dis_y=win_y=320;
  palette_size=256;
  
  if((dis_x % win_x) || (dis_y % win_y))
	{
	  printf("Display size: %d,%d\n",dis_x,dis_y);
	  panic("Display size must be exact multiple of window size");
	}

  signal(SIGALRM,graph_tsig);
  maketimer();
}

void graph_palette(short *p)
{
		;
}
  
void graph_show()
{
		;
}

void graph_shutdown()
{
		;
}

long graph_xsize()
{
  return win_x;
}

long graph_ysize()
{
  return win_y;
}

long graph_psize()
{
  return palette_size;
}
