/*
	Colour palette manipulation
*/

#define MAXPALS	16

void palette_init();	/* Initialise palette - call *after* graph_init() */
short *palette_get();	/* Get a pointer to the palette */
short palette_isinit(); /* returns true if palette is now running */
long palette_new(int size);	/* allocate palette, return handle */

/* palette values are set as RGB longwords */
#define	PALRED(x)	(((x)>>16L)&0xff)	/* get red val from RGB */
#define	PALGREEN(x)	(((x)>>8L)&0xff)	/* get green val from RGB */
#define	PALBLUE(x)	((x)&0xff)		/* get blue val from RGB */
#define	PALRGB(r,g,b)	(((r)<<16L)+((g)<<8L)+b)/* make RGB value */

void palette_set(int h,int index,unsigned long col);
void palette_reset();		/* clear all palettes */

/* automatic palette generator */

/*
  p:	palette number
  fg:	foregnd colour
  bg:	backgnd colour
  up:	% of palette in bg->fg ramp
  down:	% of palette in fg->bg ramp
  offset: % offset before ramping up
*/

void palette_gen(int h,unsigned long fore,unsigned long back,
	long up,long down,long offset);
void palette_speed(int h,int s); /* set palette speed (high=slow) */

/* the palette maker takes all the palettes and
   adds them together into the master palette, shifting
   the palettes along according to their speeds. */

void palette_run();	/* run the palette once */


void palette_startfadeout(int r,int g,int b,int s);
void palette_startfadein(int s);
int palette_isfadedone();

/*
Library calls
*/

void L_NewPalette();
void L_PaletteSet();
void L_PaletteReset();
void L_GenPalette();
void L_PaletteSpeed();
void L_MkRGB();
void L_MkHSV();
