#include "spring.h"
#include "math.h"
#include "buffer.h"
#include "graphics.h"
#include "waves.h"
#include "inter.h"

#include <stdio.h>
#include <math.h>

static char rcsid[]="$Id: plasma.c,v 1.4 1994/09/25 19:59:42 white Exp $";

#define rndm(x)	(rand()%(x))

/* Plasma code based on OOZE.C, written by Jeff Clough for the IBM/PCs. */


void draw_grid(int,int,long,unsigned char *);
short adjust(int,int,int,int,int,int,unsigned char *); 
void subdiv (int,int,int,int,unsigned char *); 

static int numcolors,trellmode,graininess;
long intens;
/* Generate a plasma cloud */
void draw_plasma(int trell,int grain)
{
  int x,y;
  unsigned char *grid; /* grid is a list of the colors */   

  numcolors=graph_psize();
  trellmode=trell;graininess=grain;

  /* Grid used to be a seperate buffer. Now we'll make it the
     main screen buffer. */

  grid=bufferdata;
  buffer_clear();

  x=graph_xsize()-1;
  y=graph_ysize()-1;
  draw_grid(0,0,rndm(numcolors),grid);
  draw_grid(x,0,rndm(numcolors),grid);
  draw_grid(0,y,rndm(numcolors),grid);
  draw_grid(x,y,rndm(numcolors),grid);
  subdiv(0,0,x,y,grid); 
}

void draw_grid(int x, int y, long colr,unsigned char *grid)
{
  grid[x+y*graph_xsize()]=colr;

  colr*=intens;
  colr/=100;
  
/*  buffer_point(x,y,colr);
*/
}

void subdiv(int x1,int y1, int x2, int y2, unsigned char *grid)
{
  int x,y;
  if (x2-x1<2 && y2-y1<2)
    return;

  graph_check();
  
  x=(x1+x2)/2;
  y=(y1+y2)/2;
  adjust(x1,y1,x,y1,x2,y1,grid);
  adjust(x2,y1,x2,y,x2,y2,grid);
  adjust(x1,y2,x,y2,x2,y2,grid);
  adjust(x1,y1,x1,y,x1,y2,grid);
  if(!grid[x+y*graph_xsize()])
    {
      short spooge;
      if (trellmode)
	spooge=(grid[x1+y1*graph_xsize()]+grid[x1+y2*graph_xsize()]+
		grid[x2+y1*graph_xsize()]+grid[x2+y2*graph_xsize()])%numcolors; 
      else
	spooge=(grid[x1+y1*graph_xsize()]+grid[x1+y2*graph_xsize()]+
		grid[x2+y1*graph_xsize()]+grid[x2+y2*graph_xsize()])/4; 
      draw_grid(x,y,spooge,grid);
    }
  subdiv(x1,y1,x,y,grid);
  subdiv(x,y1,x2,y,grid);
  subdiv(x1,y,x,y2,grid);
  subdiv(x,y,x2,y2,grid);
}

short adjust(int x1, int y1, int x, int y, int x2, int y2,
	     unsigned char *grid)
{
  short c;
  int d;
  int spoo;
  short clr1,clr2,clr3,clr4;
  long horz,vert;
  if (grid[x+y*graph_xsize()]!=0)
    return grid[x+y*graph_xsize()];
  clr1=grid[x1+y1*graph_xsize()];
  clr2=grid[x2+y2*graph_xsize()];
  clr3=grid[x1+y2*graph_xsize()];
  clr4=grid[x2+y1*graph_xsize()];
  horz=x2-x1;
  vert=y2-y1;
  d=(int)hypot((double)horz,(double)vert);
/*sqrt(horz*horz+vert*vert);*/
/* leave the next 8 lines commented out for mellow colors...*/
  if((spoo=rndm(100))>graininess)
    {
      if(spoo%2==1)
	c=(((clr1+clr2)/2)+rndm(d))%numcolors;
      else
	c=(((clr1+clr2)/2)-rndm(d))%numcolors;
    }
  else 

    c=((clr1+clr2+clr3+clr4)/4); /* %numcolors; */
  if(c<0)
    c=abs(c);
  else if(c==0)
    c=1;
  draw_grid(x,y,c,grid);
  return c;
}

void L_Plasma()
{
		long t,g;

		intens=Pop();
		
		t=Pop();
		g=Pop();
		draw_plasma(t,g);
}
